<template>
    <div>
        <PlaceholderField :placeholder="placeholder" />
        <QuestImg :src="isDefault ? localSrc : src" :is-default="isDefault" />

        <input
            :key="!!localSrc"
            type="file"
            @change="loadHandler"
            @input="$input"
            :accept="accept || 'image/jpeg, image/png'"
            :id="`upload_${_uid}`"
            hidden
        />
        <label v-show="!disabled" :for="`upload_${_uid}`">Choose file</label>

        <QuestBtn v-if="fileData" @click="fileData = null">X</QuestBtn>
        <ErrorsField :errors="locErrors" />
    </div>
</template>

<script>
import QuestImg from "@/components/QuestImg";
import ErrorsMixin from "@/mixins/errorsMixin";
import ErrorsField from "@/components/ErrorsField";
import PlaceholderField from "@/components/PlaceholderField";
import QuestBtn from "@/components/QuestBtn";
export default {
    name: "QuestFileInput",
    components: { QuestBtn, PlaceholderField, ErrorsField, QuestImg },
    props: {
        value: File,
        src: String,
        accept: String,
        placeholder: String,
        disabled: Boolean,
    },
    mixins: [ErrorsMixin],
    data: () => ({ localSrc: "" }),
    methods: {
        loadHandler({ target: { files } }) {
            const reader = new FileReader();
            const file = files[0];
            reader.readAsDataURL(file);
            reader.onload = () => {
                this.localSrc = reader.result;
                this.fileData = file;
            };
        },
    },
    computed: {
        isDefault() {
            return !!this.localSrc;
        },
        fileData: {
            get() {
                return this.value;
            },
            set(value) {
                this.$emit("input", value);
            },
        },
    },
    watch: {
        fileData(value) {
            if (!value) this.localSrc = "";
        },
    },
};
</script>

<style scoped></style>
